package com.github.itzilly.sbt.command

import net.minecraft.command.CommandBase
import net.minecraft.command.ICommandSender
import net.minecraft.util.BlockPos
import net.minecraftforge.client.ClientCommandHandler

fun registerBaseCommand() {
    ClientCommandHandler.instance.registerCommand(object : CommandBase() {
        override fun getCommandName() = "sbt"
        override fun getCommandUsage(sender: ICommandSender) = "/sbt <subcommand>"

        override fun processCommand(sender: ICommandSender, args: Array<out String>) {
            ModCommandRegistry.dispatch(CommandContext(sender, args))
        }

        override fun addTabCompletionOptions(
            sender: ICommandSender,
            args: Array<out String>,
            pos: BlockPos?
        ): List<String>? {
            return if (args.size == 1) {
                ModCommandRegistry.subcommands.keys.toList().distinct().filter { it.startsWith(args[0]) }
            } else null
        }

        override fun canCommandSenderUseCommand(sender: ICommandSender): Boolean {
            return true
        }
    })
}