package com.github.itzilly.sbt.command

import com.github.itzilly.sbt.features.GrottoFinder
import com.github.itzilly.sbt.util.Chatterbox
import com.github.itzilly.sbt.util.SimpleChatMsg

object ClientCommands {

    @SubCommand(
        name = "autogrotto",
        usage = "<status|enable|disable>",
        description = "Manages the AutoGrotto feature"
    )
    fun autogrotto(ctx: CommandContext) {
        val action = ctx.arg(0)?.lowercase()

        when (action) {
            "status" -> {
                val isEnabled = GrottoFinder.isAutoDetectEnabled()
                Chatterbox.say("Autogrotto is currently ${if (isEnabled) "enabled" else "disabled"}")
            }

            "enable", "on" -> {
                GrottoFinder.enableAutoDetect()
                Chatterbox.say("Autogrotto has been enabled")
            }

            "disable", "off" -> {
                GrottoFinder.disableAutoDetect()
                Chatterbox.say("Autogrotto has been disabled")
            }

            else -> {
                Chatterbox.say(SimpleChatMsg("Invalid argument! Usage:").red())
                Chatterbox.say("/sbt autogrotto <status | enable/on | disable/off>")
            }
        }
    }

    @SubCommand(
        name = "reveal_grotto",
        usage = "",
        description = "Reveal Grotto"
    )
    fun reveal_grotto(ctx: CommandContext) {
        GrottoFinder.revealDetectedJasperBlocks()
    }
}