package com.github.itzilly.sbt.util

import net.minecraft.client.Minecraft

fun getMiniServerIdFromScoreboard(): String? {
    val scoreboard = Minecraft.getMinecraft().theWorld?.scoreboard ?: return null
    val objective = scoreboard.getObjectiveInDisplaySlot(1) ?: return null

    return scoreboard.getSortedScores(objective)
        .mapNotNull { score ->
            try {
                score.playerName
            } catch (e: Exception) {
                null
            }
        }
        .map { it.replace(Regex("§."), "").trim() }
        .firstOrNull { it.matches(Regex("^\\[mini\\w+]$")) }
}